Перем _КэшПутей;
Перем _КэшСоответствий;
Перем _Лог;
Перем _КаталогИсходников;

Процедура ПриСозданииОбъекта( Знач пКаталогИсходников, Знач пЛог )
	
	_КаталогИсходников = пКаталогИсходников;
	_Лог = пЛог;
	
	_КэшПутей = Новый Соответствие;
	
	_КэшСоответствий = Новый Структура;
	
	_КэшСоответствий.Вставить( "Метаданные", СоответствиеМетаданнымКаталогам() );
	_КэшСоответствий.Вставить( "Модули", СоответствиеМодулейФайлам() );
	
КонецПроцедуры

Функция Путь( Знач пМетаданные ) Экспорт
	
	путь = _КэшПутей.Получить( пМетаданные );
	
	Если ЗначениеЗаполнено( путь ) Тогда
		Возврат путь;
	КонецЕсли;
	
	компоненты = СтрРазделить( пМетаданные, "." );
	
	Если компоненты.Количество() = 0 Тогда
		
		Возврат "";
		
	КонецЕсли;
	
	компонентыПути = Новый Массив;
	компонентыПути.Добавить( _КаталогИсходников );
	
	// Тип метаданных
	
	имяМетаданных = ВРег( компоненты[0] );
	
	каталог = _КэшСоответствий.Метаданные[ имяМетаданных ];
	
	Если Не ЗначениеЗаполнено( каталог ) Тогда
		
		Возврат "";
		
	КонецЕсли;
	
	Если компоненты.Количество() < 3 Тогда
		
		Возврат "";
		
	КонецЕсли;
	
	компонентыПути.Добавить( каталог );
	
	// Имя объекта	
	
	компонентыПути.Добавить( компоненты[1] );
	
	типОбъекта = ВРег( компоненты[2] );
	
	имяФайла = _КэшСоответствий.Модули[типОбъекта];
	
	Если ЗначениеЗаполнено( имяФайла ) Тогда
		
		компонентыПути.Добавить( "Ext" );
		компонентыПути.Добавить( имяФайла );
		
	ИначеЕсли имяМетаданных = "ОБЩАЯФОРМА" Тогда
		
		компонентыПути.Добавить( "Ext" );
		компонентыПути.Добавить( "Form" );
		компонентыПути.Добавить( "Module.bsl" );
		
	ИначеЕсли типОбъекта = "ФОРМА" Тогда
		
		компонентыПути.Добавить( "Forms" );
		
		Если компоненты.Количество() > 3 Тогда
			
			компонентыПути.Добавить( компоненты[3] );
			
		КонецЕсли;
		
		Если компоненты.Количество() > 5 Тогда
			
			Если ВРег( компоненты[4] ) = "ФОРМА"
				И ВРег( компоненты[5] ) = "МОДУЛЬ" Тогда
				
				компонентыПути.Добавить( "Ext" );
				компонентыПути.Добавить( "Form" );
				компонентыПути.Добавить( "Module.bsl" );
				
			КонецЕсли;
			
		КонецЕсли;
		
	ИначеЕсли типОбъекта = "КОМАНДА" Тогда
		
		компонентыПути.Добавить( "Commands" );
		
		Если компоненты.Количество() > 3 Тогда
			
			компонентыПути.Добавить( компоненты[3] );
			
		КонецЕсли;
		
		Если компоненты.Количество() > 4 Тогда
			
			Если ВРег( компоненты[4] ) = "МОДУЛЬКОМАНДЫ" Тогда
				
				компонентыПути.Добавить( "Ext" );
				компонентыПути.Добавить( "CommandModule.bsl" );
				
			КонецЕсли;
			
		КонецЕсли;
		
	КонецЕсли;
	
	путь = СтрСоединить( компонентыПути, ПолучитьРазделительПути() );
	
	_КэшПутей.Вставить( пМетаданные, путь );
	
	Возврат путь;
	
КонецФункции

Процедура ПроверитьПуть( Знач пПуть, Знач пМетаданные ) Экспорт
	
	Если Не ЗначениеЗаполнено( пПуть ) Тогда
		
		_лог.Ошибка( СтрШаблон( "Путь для <%1> не получен", пМетаданные) );
		
	ИначеЕсли Не ОбщегоНазначения.ФайлСуществует( пПуть ) Тогда
		
		_лог.Ошибка( СтрШаблон( "Путь <%1> для <%2> не существует", пПуть, пМетаданные) );
		
	КонецЕсли;
	
КонецПроцедуры

Функция СоответствиеМетаданнымКаталогам()
	
	Соответствие = Новый Соответствие();
	
	Соответствие.Вставить( "РегистрБухгалтерии", "AccountingRegisters" );
	Соответствие.Вставить( "РегистрНакопления", "AccumulationRegisters" );
	Соответствие.Вставить( "БизнесПроцесс", "BusinessProcesses" );
	Соответствие.Вставить( "РегистрРасчета", "CalculationRegisters" );
	Соответствие.Вставить( "Справочник", "Catalogs" );
	Соответствие.Вставить( "ПланСчетов", "ChartsOfAccounts" );
	Соответствие.Вставить( "ПланВидовРасчета", "ChartsOfCalculationTypes" );
	Соответствие.Вставить( "ПланВидовХарактеристик", "ChartsOfCharacteristicTypes" );
	Соответствие.Вставить( "ОбщаяГруппа", "CommandGroups" );
	Соответствие.Вставить( "ОбщийРеквизит", "CommonAttributes" );
	Соответствие.Вставить( "ОбщаяКоманда", "CommonCommands" );
	Соответствие.Вставить( "ОбщаяФорма", "CommonForms" );
	Соответствие.Вставить( "ОбщийМодуль", "CommonModules" );
	Соответствие.Вставить( "ОбщаяКартинка", "CommonPictures" );
	Соответствие.Вставить( "ОбщийМакет", "CommonTemplates" );
	Соответствие.Вставить( "Константа", "Constants" );
	Соответствие.Вставить( "Обработка", "DataProcessors" );
	Соответствие.Вставить( "ОпределяемыйТип", "DefinedTypes" );
	Соответствие.Вставить( "ЖурналДокумента", "DocumentJournals" );
	Соответствие.Вставить( "Нумератор", "DocumentNumerators" );
	Соответствие.Вставить( "Документ", "Documents" );
	Соответствие.Вставить( "Перечисление", "Enums" );
	Соответствие.Вставить( "ПодпискаНаСобытие", "EventSubscriptions" );
	Соответствие.Вставить( "ПланОбмена", "ExchangePlans" );
	Соответствие.Вставить( "ВнешнийИсточник", "ExternalDataSources" );
	Соответствие.Вставить( "КритерийОтбора", "FilterCriteria" );
	Соответствие.Вставить( "ФункциональнаяОпция", "FunctionalOptions" );
	Соответствие.Вставить( "ПарамертФункциональыхОпций", "FunctionalOptionsParameters" );
	Соответствие.Вставить( "HTTPСервис", "HTTPServices" );
	Соответствие.Вставить( "РегистрСведений", "InformationRegisters" );
	Соответствие.Вставить( "Язык", "Languages" );
	Соответствие.Вставить( "Отчет", "Reports" );
	Соответствие.Вставить( "Роль", "Roles" );
	Соответствие.Вставить( "РегламентноеЗадание", "ScheduledJobs" );
	Соответствие.Вставить( "Последовательность", "Sequences" );
	Соответствие.Вставить( "ПарамертСеанса", "SessionParameters" );
	Соответствие.Вставить( "ХранилищеНастроек", "SettingsStorages" );
	Соответствие.Вставить( "ЭлементСтиля", "StyleItems" );
	Соответствие.Вставить( "Подсистема", "Subsystems" );
	Соответствие.Вставить( "Задача", "Tasks" );
	Соответствие.Вставить( "WebСервис", "WebServices" );
	Соответствие.Вставить( "XDTOПакет", "XDTOPackages" );
	Соответствие.Вставить( "XDTOPackage", "XDTOPackages" );
	
	соотВРег = Новый Соответствие;
	
	Для Каждого цЭлемент Из Соответствие Цикл
		
		соотВРег.Вставить( ВРег( цЭлемент.Ключ ), цЭлемент.Значение );
		
	КонецЦикла;
	
	Возврат соотВРег;
	
КонецФункции

Функция СоответствиеМодулейФайлам()
	
	Соответствие = Новый Соответствие();
	
	Соответствие.Вставить( "МОДУЛЬОБЪЕКТА", "ObjectModule.bsl" );
	Соответствие.Вставить( "МОДУЛЬ", "Module.bsl" );
	Соответствие.Вставить( "МОДУЛЬМЕНЕДЖЕРА", "ManagerModule.bsl" );
	Соответствие.Вставить( "МОДУЛЬНАБОРАЗАПИСЕЙ", "RecordSetModule.bsl" );
	Соответствие.Вставить( "МОДУЛЬМЕНЕДЖЕРАЗНАЧЕНИЯ", "ValueManagerModule.bsl" );
	Соответствие.Вставить( "МОДУЛЬКОМАНДЫ", "CommandModule.bsl" );
	Соответствие.Вставить( "PACKAGE", "Package.bin" );
	
	Возврат Соответствие;
	
КонецФункции
